<?php

namespace SM\Controller;

use SM\Traits\TResponse;
use Zeedhi\Framework\DTO\Request;
use Zeedhi\Framework\DTO\Response;
use SM\Service\RelatorioCdaService;
use Zeedhi\Framework\DataSource\DataSet;

class RelatorioCdaController
{
    use TResponse;

    protected $RelatorioCdaService;

    public function __construct(RelatorioCdaService $RelatorioCdaService)
    {
        $this->RelatorioCdaService = $RelatorioCdaService;
    }

    public function getRelatorioCda(Request $request)
    {
        try {
            $data = $this->RelatorioCdaService->getRelatorioCda($request->getParameters());
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function getFuncRelCda(Request $request)
    {
        try {
            $data = $this->RelatorioCdaService->getFuncRelCda($request->getParameters());
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function getPerfAcesRelCda()
    {
        try {
            $data = $this->RelatorioCdaService->getPerfAcesRelCda();
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function getClienteRelCda(Request $request)
    {
        try {
            $data = $this->RelatorioCdaService->getClienteRelCda($request->getParameters());
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function getPropostaCdaRel(Request $request)
    {
        try {
            $data = $this->RelatorioCdaService->getPropostaCdaRel($request->getParameters());
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function getProjetoCdaRel(Request $request)
    {
        try {
            $data = $this->RelatorioCdaService->getProjetoCdaRel($request->getParameters());
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function getTypeOfActivityCdaRel(Request $request)
    {
        try {
            $data = $this->RelatorioCdaService->getTypeOfActivityCdaRel($request->getParameters());
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }
}
