<?php

namespace SM\Controller;

use Zeedhi\Framework\DTO\Request;
use Zeedhi\Framework\DTO\Response;
use Zeedhi\Framework\DataSource\DataSet;
use SM\Service\SmAgrupamentoEscopoService;
use SM\Traits\TResponse;

class SmAgrupamentoEscopoController
{

    use TResponse;
    protected $AgrupamentoService;

    public function __construct(SmAgrupamentoEscopoService $AgrupamentoService)
    {
        $this->AgrupamentoService = $AgrupamentoService;
    }

    public function getAgrupamentoEscopoFaturamento()
    {
        try {
            $data = $this->AgrupamentoService->getAgrupamentoEscopoFaturamento();
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function insertAgrupamentoTipoOrca(Request $request)
    {
        try {
            $data = $this->AgrupamentoService->insertAgrupamentoTipoOrca($request->getParameters());
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function getSerieNotaFiscal(Request $request)
    {
        try {
            $data = $this->AgrupamentoService->getSerieNotaFiscal($request->getParameters());
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function getMunicipio(Request $request)
    {
        try {
            $data = $this->AgrupamentoService->getMunicipio($request->getParameters());
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function getEscoposParaAgrupar(Request $request)
    {
        try {
            $data = $this->AgrupamentoService->getEscoposParaAgrupar($request->getParameters());
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }
    

    public function getEscoposAgrupados(Request $request)
    {
        try {
            $data = $this->AgrupamentoService->getEscoposAgrupados($request->getParameters());
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function agruparEscopo(Request $request)
    {
        try {
            $data = $this->AgrupamentoService->agruparEscopo($request->getParameters());
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function excluirEscoposAgrupados(Request $request)
    {
        try {
            $data = $this->AgrupamentoService->excluirEscoposAgrupados($request->getParameters());
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }
}
