<?php
namespace SM\Service;

use SM\Factory\ConfContratoMotivoNegociacaoFactory;
use Teknisa\Libs\Util\Environment;
use Teknisa\Libs\Util\NewCode;
use Doctrine\ORM\EntityManager;

class ConfContratoMotivoNegociacaoService
{

    protected $motivoNegociacaoFactory;
    protected $Environment;
    protected $newCode;

    public function __construct(EntityManager $entityManager, ConfContratoMotivoNegociacaoFactory $motivoNegociacaoFactory, Environment $Environment, NewCode $newCode)
    {
        $this->connection              = $entityManager->getConnection();
        $this->motivoNegociacaoFactory = $motivoNegociacaoFactory;
        $this->Environment             = $Environment;
        $this->newCode                 = $newCode;
    }

    public function getMotivos()
    {
        return $this->motivoNegociacaoFactory->getMotivos();
    }

    public function salvarMotivos($params)
    {
        $this->connection->beginTransaction();

        try {
            $nrorg = $this->Environment->getNrorg();
            $operador = $this->Environment->getCdOperador();
            
            foreach ($params["DRG"] as $row) {
                if ($row["NRMOTIVOPARALISACAO"] != 0) {
                    $parametros = array (
                        "NRMOTIVOPARALISACAO"   => $row["NRMOTIVOPARALISACAO"],
                        "IDATIVO"               => $row["IDATIVO"],
                        "DSMOTIVOPARALISACAO"   => $row['DSMOTIVOPARALISACAO'],
                        "NRORGULTATU"           => $nrorg,
                        "CDOPERULTATU"          => $operador
                    );

                    $this->motivoNegociacaoFactory->editarMotivos($parametros);
                } else {
                    $nrmotivoparalisacao = $this->newCode->getCodeByTableName("FCT_MOTIVOPARALISACAO", $nrorg, 1, 10, true);

                    $parametros = array(
                        "NRMOTIVOPARALISACAO"   => $nrmotivoparalisacao,
                        "IDATIVO"               => $row['IDATIVO'],
                        "DSMOTIVOPARALISACAO"   => $row['DSMOTIVOPARALISACAO'],
                        "NRORG"                 => $nrorg,
                        "NRORGINCLUSAO"         => $nrorg,
                        "CDOPERINCLUSAO"        => $operador,
                    );
                    
                    $this->motivoNegociacaoFactory->salvarMotivos($parametros);
                }
            }
            $this->connection->commit();
        } catch (\Exception $e) {
            $this->connection->rollback();
            throw $e;
        }
    }

    public function excluirMotivos($parametro)
    {
        $param = implode(',', $parametro["NRS"]);
        $this->motivoNegociacaoFactory->excluirMotivos($param);
    }
}
